'======================================================================
'Mehrere Schrittmotoren unipolar und in Halbschritten ansteuern
'======================================================================

$regfile = "m8def.dat"
$crystal = 8000000
$hwstack = 100
$swstack = 100
$framesize = 100


'Status-LEDs
Lde1 Alias Portc.3
Config Led1 = Output

Lde2 Alias Portc.4
Config Led2 = Output

Lde3 Alias Portc.5
Config Led3 = Output


'Schrittmotor 1
St1_a Alias Portd.6
Config St1_a = Output

St1_b Alias Portb.0
Config St1_b = Output

St1_c Alias Portd.7
Config St1_c = Output

St1_d Alias Portd.5
Config St1_d = Output


'Schrittmotor 2
St2_a Alias Portd.4
Config St2_a = Output

St2_b Alias Portb.7
Config St2_b = Output

St2_c Alias Portb.6
Config St2_c = Output

St2_d Alias Portb.5
Config St2_d = Output


'Schrittmotor 3
St3_a Alias Portb.2
Config St3_a = Output

St3_b Alias Portb.4
Config St3_b = Output

St3_c Alias Portb.3
Config St3_c = Output

St3_d Alias Portb.1
Config St3_d = Output


'Anzahl an Schrittmotoren
Const Stepper_quant = 3


'Der Timer wird bei jedem berlauf mit LOAD so eingestellt, dass nach der hier
'festgelegten Anzahl an Timer-Ticks der Timer wieder berluft.
'Das ergibt bei nur einem gezhlten Timer-Tick:
'8000000 / 1024 / 1 = 7812 berlufe des Timer0 die Sekunde
Const Timer_preset = 1

'Ticker_value(X) wird mit jedem Timer0-berlauf erhht
Dim Ticker_value(stepper_quant) As Word

'Wird Max_wait_ticks(X) erreicht, dann wird Ticker_value(X) auf 0 zurck gesetzt
'und der nchste Schritt des Schrittmotors ausgefhrt
'Maximale Geschwindigkeit = 10
'Minimale Geschwindigkeit = 600
Dim Max_wait_ticks(stepper_quant) As Word

'Current_step(X) zeigt auf den derzeit anliegenden Schrittmotor-Schritt
Dim Current_step(stepper_quant) As Byte

'Direction(X) gibt die Richtung an, in die der Schrittmotor luft.
'0 = vorwrts
'1 = rckwrts
Dim Direction(stepper_quant) As Byte


Dim Current_stepper As Byte
Dim _current_stepper As Byte       'wird in <On_timer0> verwendet
Dim Tmp As Byte
Dim Tmp_single As Single
Dim Adcvalue As Word

'Schritte zur Ansteuerung der Schrittmotoren
Dim Stepvalue(8) As Byte
Stepvalue(1) = &B00001001
Stepvalue(2) = &B00000001
Stepvalue(3) = &B00000101
Stepvalue(4) = &B00000100
Stepvalue(5) = &B00000110
Stepvalue(6) = &B00000010
Stepvalue(7) = &B00001010
Stepvalue(8) = &B00001000

'8000000 / 1024 / 2 = 3906 berlufe die Sekunde
Config Timer0 = Timer , Prescale = 1024
On Timer0 On_timer0
Enable Timer0
Enable Interrupts

'ADC einstellen und aktivieren
Config Adc = Single , Prescaler = Auto , Reference = Avcc


Do
   'Jedes Poti durchlaufen, messen und <max_wait_ticks> daraus berechnen
   For Current_stepper = 1 To Stepper_quant
      Tmp = Current_stepper - 1
      Adcvalue = Getadc(tmp)
      If Adcvalue <= 10 Then
         Max_wait_ticks(current_stepper) = 0
         'Status-LED ausschalten
         Select Case _current_stepper
         Case 1 : Reset Led1
         Case 2 : Reset Led2
         Case 3 : Reset Led3
         End Select
      Else
         'Ursprngliche Formel, die noch fr ``Timer_preset = 2`` galt:
         '<max_wait_ticks> = 300 - (295 / 100 * (100 / 1014 * (<adcvalue> - 10)))
         Tmp_single = Adcvalue
         Tmp_single = Tmp_single - 10
         Tmp_single = 0.098619 * Tmp_single
         Tmp_single = 0.84 * Tmp_single       'ursprnglich: 2.95 * tmp_double
         Tmp_single = 100 - Tmp_single       'ursprnglich: 300 - Tmp_double
         Max_wait_ticks(current_stepper) = Tmp_single
         'Status-LED einschalten
         Select Case _current_stepper
         Case 1 : Set Led1
         Case 2 : Set Led2
         Case 3 : Set Led3
         End Select
      End If
   Next Current_stepper

   Waitms 50
Loop

End


On_timer0:
   'Timer so setzen, dass der berlauf nach <Timer_preset> Ticks wieder auftritt
   Load Timer0 , Timer_preset

   'Jeden Schrittmotor durchlaufen
   For _current_stepper = 1 To Stepper_quant
      If Max_wait_ticks(_current_stepper) > 0 Then
         'Ticker erhhen und prfen ob der nchste Schritt durchgefhrt
         'werden soll
         Incr Ticker_value(_current_stepper)
         If Ticker_value(_current_stepper) >= Max_wait_ticks(_current_stepper) Then

            Ticker_value(_current_stepper) = 0

            'Nchsten Schritt festlegen
            If Direction(_current_stepper) = 0 Then
               'vorwrts
               Incr Current_step(_current_stepper)
               If Current_step(_current_stepper) > 8 Then
                  Current_step(_current_stepper) = 1
               End If
            Else
               'rckwrts
               Decr Current_step(_current_stepper)
               If Current_step(_current_stepper) < 1 Then
                  Current_step(_current_stepper) = 8
               End If
            End If

            'Nchsten Schritt einstellen
            Select Case _current_stepper
            Case 1
               St1_a = Stepvalue(current_step(_current_stepper)).0
               St1_b = Stepvalue(current_step(_current_stepper)).1
               St1_c = Stepvalue(current_step(_current_stepper)).2
               St1_d = Stepvalue(current_step(_current_stepper)).3
            Case 2
               St2_a = Stepvalue(current_step(_current_stepper)).0
               St2_b = Stepvalue(current_step(_current_stepper)).1
               St2_c = Stepvalue(current_step(_current_stepper)).2
               St2_d = Stepvalue(current_step(_current_stepper)).3
            Case 3
               St3_a = Stepvalue(current_step(_current_stepper)).0
               St3_b = Stepvalue(current_step(_current_stepper)).1
               St3_c = Stepvalue(current_step(_current_stepper)).2
               St3_d = Stepvalue(current_step(_current_stepper)).3
            End Select
         End If
      Else
         'Schrittmotor stoppen
         Select Case _current_stepper
         Case 1
            Reset St1_a
            Reset St1_b
            Reset St1_c
            Reset St1_d
         Case 2
            Reset St2_a
            Reset St2_b
            Reset St2_c
            Reset St2_d
         Case 3
            Reset St3_a
            Reset St3_b
            Reset St3_c
            Reset St3_d
         End Select
      End If
   Next _current_stepper
Return

